3 USAGE='[start|bad|good|skip|next|reset|visualize|replay|log|run]'
4 LONG_USAGE='git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
5 reset bisect state and start bisection.
7 mark <rev> a known-bad revision.
8 git bisect good [<rev>...]
9 mark <rev>... known-good revisions.
10 git bisect skip [<rev>...]
11 mark <rev>... untestable revisions.
13 find next bisection to test and check it out.
14 git bisect reset [<branch>]
15 finish bisection search and go back to branch.
17 show bisect status in gitk.
18 git bisect replay <logfile>
22 git bisect run <cmd>...
23 use <cmd>... to automatically bisect.'
29 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
30 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35 s/'\''/'\'\\\\\'\''/g;
43 test -f "$GIT_DIR/BISECT_NAMES" || {
44 echo >&2 'You need to start by "git bisect start"'
47 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
62 # Verify HEAD. If we were bisecting before this, reset to the
63 # top-of-line master first!
65 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref HEAD) ||
66 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
67 die "Bad HEAD - I need a HEAD"
70 if [ -s "$GIT_DIR/BISECT_START" ]; then
71 branch=`cat "$GIT_DIR/BISECT_START"`
75 git checkout $branch || exit
78 # This error message should only be triggered by cogito usage,
79 # and cogito users should understand it relates to cg-seek.
80 [ -s "$GIT_DIR/head-name" ] && die "won't bisect on seeked tree"
81 echo "${head#refs/heads/}" >"$GIT_DIR/BISECT_START"
84 die "Bad HEAD - strange symbolic ref"
89 # Get rid of any old bisect state
94 # Check for one bad and then some good revisions.
98 case "$arg" in --) has_double_dash=1; break ;; esac
102 while [ $# -gt 0 ]; do
110 rev=$(git rev-parse --verify "$arg^{commit}" 2>/dev/null) || {
111 test $has_double_dash -eq 1 &&
112 die "'$arg' does not appear to be a valid revision"
116 0) state='bad' ; bad_seen=1 ;;
119 bisect_write "$state" "$rev" 'nolog'
125 sq "$@" >"$GIT_DIR/BISECT_NAMES"
126 echo "git-bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG"
136 good|skip) tag="$state"-"$rev" ;;
137 *) die "Bad bisect_write argument: $state" ;;
139 git update-ref "refs/bisect/$tag" "$rev"
140 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
141 test -z "$nolog" && echo "git-bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
149 die "Please call 'bisect_state' with at least one argument." ;;
151 rev=$(git rev-parse --verify HEAD) ||
152 die "Bad rev input: HEAD"
153 bisect_write "$state" "$rev" ;;
155 rev=$(git rev-parse --verify "$2^{commit}") ||
156 die "Bad rev input: $2"
157 bisect_write "$state" "$rev" ;;
160 revs=$(git rev-parse --revs-only --no-flags "$@") &&
161 test '' != "$revs" || die "Bad rev input: $@"
164 rev=$(git rev-parse --verify "$rev^{commit}") ||
165 die "Bad rev commit: $rev^{commit}"
166 bisect_write "$state" "$rev"
174 bisect_next_check() {
175 missing_good= missing_bad=
176 git show-ref -q --verify refs/bisect/bad || missing_bad=t
177 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
179 case "$missing_good,$missing_bad,$1" in
181 : have both good and bad - ok
184 # do not have both but not asked to fail - just report.
188 # have bad but not good. we could bisect although
189 # this is less optimum.
190 echo >&2 'Warning: bisecting only with a bad commit.'
193 printf >&2 'Are you sure [Y/n]? '
194 case "$(read yesno)" in [Nn]*) exit 1 ;; esac
196 : bisect without good...
200 test -f "$GIT_DIR/BISECT_NAMES" || {
201 echo >&2 'You need to start by "git bisect start".'
204 echo >&2 'You '$THEN'need to give me at least one good' \
205 'and one bad revisions.'
206 echo >&2 '(You can use "git bisect bad" and' \
207 '"git bisect good" for that.)'
213 bisect_next_check && bisect_next || :
220 if [ -z "$_skip" ]; then
225 # Let's parse the output of:
226 # "git rev-list --bisect-vars --bisect-all ..."
227 eval $_eval | while read hash line
229 case "$VARS,$FOUND,$TRIED,$hash" in
230 # We display some vars.
231 1,*,*,*) echo "$hash $line" ;;
236 # We had nothing to search.
242 # We did not find a good bisect rev.
243 # This should happen only if the "bad"
244 # commit is also a "skip" commit.
246 echo "bisect_rev=$TRIED"
252 TRIED="${TRIED:+$TRIED|}$hash"
256 echo "bisect_rev=$hash"
257 echo "bisect_tried=\"$TRIED\""
263 # We have already found a rev to be tested.
264 ,1,*,bisect_rev*) VARS=1 ;;
268 *) die "filter_skipped error " \
279 exit_if_skipped_commits () {
281 if expr "$_tried" : ".*[|].*" > /dev/null ; then
282 echo "There are only 'skip'ped commit left to test."
283 echo "The first bad commit could be any of:"
284 echo "$_tried" | tr '[|]' '[\012]'
285 echo "We cannot bisect more!"
291 case "$#" in 0) ;; *) usage ;; esac
293 bisect_next_check good
295 skip=$(git for-each-ref --format='%(objectname)' \
296 "refs/bisect/skip-*" | tr '[\012]' ' ') || exit
299 test -n "$skip" && BISECT_OPT='--bisect-all'
301 bad=$(git rev-parse --verify refs/bisect/bad) &&
302 good=$(git for-each-ref --format='^%(objectname)' \
303 "refs/bisect/good-*" | tr '[\012]' ' ') &&
304 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
305 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
306 eval=$(filter_skipped "$eval" "$skip") &&
309 if [ -z "$bisect_rev" ]; then
310 echo "$bad was both good and bad"
313 if [ "$bisect_rev" = "$bad" ]; then
314 exit_if_skipped_commits "$bisect_tried"
315 echo "$bisect_rev is first bad commit"
316 git diff-tree --pretty $bisect_rev
320 # We should exit here only if the "bad"
321 # commit is also a "skip" commit (see above).
322 exit_if_skipped_commits "$bisect_rev"
324 echo "Bisecting: $bisect_nr revisions left to test after this"
325 git branch -f new-bisect "$bisect_rev"
326 git checkout -q new-bisect || exit
327 git branch -M new-bisect bisect
328 git show-branch "$bisect_rev"
332 bisect_next_check fail
336 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
343 -*) set git log "$@" ;;
348 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
349 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
353 test -f "$GIT_DIR/BISECT_NAMES" || {
354 echo "We are not bisecting."
358 0) if [ -s "$GIT_DIR/BISECT_START" ]; then
359 branch=`cat "$GIT_DIR/BISECT_START"`
363 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
364 die "$1 does not seem to be a valid branch"
369 if git checkout "$branch"; then
370 # Cleanup head-name if it got left by an old version of git-bisect
371 rm -f "$GIT_DIR/head-name"
372 rm -f "$GIT_DIR/BISECT_START"
377 bisect_clean_state() {
378 # There may be some refs packed during bisection.
379 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* refs/heads/bisect |
382 git update-ref -d $ref $hash
384 rm -f "$GIT_DIR/BISECT_LOG"
385 rm -f "$GIT_DIR/BISECT_NAMES"
386 rm -f "$GIT_DIR/BISECT_RUN"
390 test -r "$1" || die "cannot read $1 for replaying"
392 while read bisect command rev
394 test "$bisect" = "git-bisect" || continue
397 cmd="bisect_start $rev"
400 bisect_write "$command" "$rev" ;;
402 die "?? what are you talking about?" ;;
409 bisect_next_check fail
417 # Check for really bad run error.
418 if [ $res -lt 0 -o $res -ge 128 ]; then
419 echo >&2 "bisect run failed:"
420 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
424 # Find current state depending on run success or failure.
425 # A special exit code of 125 means cannot test.
426 if [ $res -eq 125 ]; then
428 elif [ $res -gt 0 ]; then
434 # We have to use a subshell because "bisect_state" can exit.
435 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
438 cat "$GIT_DIR/BISECT_RUN"
440 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
442 echo >&2 "bisect run cannot continue any more"
446 if [ $res -ne 0 ]; then
447 echo >&2 "bisect run failed:"
448 echo >&2 "'bisect_state $state' exited with error code $res"
452 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
453 echo "bisect run success"
471 bisect_state "$cmd" "$@" ;;
473 # Not sure we want "next" at the UI level anymore.
476 bisect_visualize "$@" ;;
480 bisect_replay "$@" ;;
482 cat "$GIT_DIR/BISECT_LOG" ;;